///+------------------------------------------------------------------+
//|                                              MTF_MACD_inColor.mq4 |
//|                                       Copyright  2006, Keris2112 |
//|  1June06 Stache  added traditional view and 2-color Histogram     |
//|  add an alert to it that will 'signal' after a crossover of 'x' bars ... 
//|  at the close of the 1st or ... 2nd ... or 3rd ... or 4th ...
//|  or the 5th ... bar after a crossover ... 
//|  set it for the close of the 'x' (3rd) or whatever I want to test ... 
 //+------------------------------------------------------------------+
#property copyright "Copyright  2006, Keris2112"
#property link      "http://www.forex-tsd.com"


#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 Yellow
#property indicator_width1 1
#property indicator_color2 CLR_NONE  //Chocolate
#property indicator_width2 1
#property indicator_color3 CLR_NONE  //SteelBlue
#property indicator_width3 1
#property indicator_color4 CLR_NONE  //Red
#property indicator_width4 1

#property indicator_level1  0
#property indicator_levelcolor Yellow
#property indicator_levelstyle 2

#include <gSpeak.mqh> 

//---- input parameters
/*************************************************************************
PERIOD_M1   1
PERIOD_M5   5
PERIOD_M15  15
PERIOD_M30  30 
PERIOD_H1   60
PERIOD_H4   240
PERIOD_D1   1440
PERIOD_W1   10080
PERIOD_MN1  43200
You must use the numeric value of the timeframe that you want to use
when you set the TimeFrame' value with the indicator inputs.
---------------------------------------
PRICE_CLOSE    0 Close price. 
PRICE_OPEN     1 Open price. 
PRICE_HIGH     2 High price. 
PRICE_LOW      3 Low price. 
PRICE_MEDIAN   4 Median price, (high+low)/2. 
PRICE_TYPICAL  5 Typical price, (high+low+close)/3. 
PRICE_WEIGHTED 6 Weighted close price, (high+low+close+close)/4. 
You must use the numeric value of the Applied Price that you want to use
when you set the 'applied_price' value with the indicator inputs.
**************************************************************************/
extern bool   SpeechOn      =true;
extern bool   AlertON       =true;
extern int    TimeFrame     =60;
extern int    FastEMA       =3;
extern int    SlowEMA       =9;
extern int    SignalSMA     =2;
extern int    Applied_Price =0;
extern int    Applied_MAMode=0;
extern int    BarsCount     =100;
extern string Price  = "0C,1O,2H,3L,4M,5T,6W";
extern string MAMode = "SMA0,EMA1,SmmMA2,LWMA3";
extern string TimeFrames = "M1,5,15,30,60H1,240H4,1440D1,10080W1,43200MN|0-CuTF";

double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
int flagval1 = 0;
int flagval2 = 0;

//----
string FinSym;             // NOTE 2 ...  addition of FinSym (Financial Symbol) to facilitate the use of Symbol() for speech.
string ChartPeriod;        // NOTE 2 ...  addition of ChartPeriod to facillitate the use of Period() for speech.

//+-----------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   
//---- indicator line
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexDrawBegin(1,SignalSMA);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+1);
   
   SetIndexBuffer(0,ExtMapBuffer1); 
   SetIndexBuffer(1,ExtMapBuffer2); 
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexBuffer(3,ExtMapBuffer4);
//---- name for DataWindow and indicator subwindow label   
   switch(TimeFrame)
   {
      case 1     : string TimeFrameStr="H1"; break;
      case 5     : TimeFrameStr=       "M5"; break;
      case 15    : TimeFrameStr=       "M15"; break;
      case 30    : TimeFrameStr=       "M30"; break;
      case 60    : TimeFrameStr=       "H1"; break;
      case 240   : TimeFrameStr=       "H4"; break;
      case 1440  : TimeFrameStr=       "D1"; break;
      case 10080 : TimeFrameStr=       "W1"; break;
      case 43200 : TimeFrameStr=       "MN1"; break;
      default    : TimeFrameStr=       "0";
   }
   IndicatorShortName("MTF_MACD ("+FastEMA+","+SlowEMA+","+SignalSMA+") ["+TimeFrameStr+"]");

  return(0);
  }
//----
  
 
//+------------------------------------------------------------------+
//| MTF MACD                                            |
//+------------------------------------------------------------------+
int start()
  {
   datetime TimeArray[];
   int    i,limit,y=0,counted_bars=IndicatorCounted();
 
// Plot defined time frame on to current time frame
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
   
   limit= Bars-counted_bars;
   limit= MathMax(limit,TimeFrame/Period());
   limit= MathMin(limit,BarsCount);
   
//--------------
if (Symbol() == "XAUUSD") FinSym = " Gold. ";
      if (Symbol() == "GBPCHF") FinSym = " British. Swiss France! ";
      if (Symbol() == "GBPUSD") FinSym = " British US. ";        // NOTE 3 ...  Provides pronunciation for the Symbol() of the chart. 
      if (Symbol() == "GBPJPY") FinSym = " British Japan. ";
      if (Symbol() == "EURJPY") FinSym = " Euro Japan. "; 
      if (Symbol() == "USDJPY") FinSym = " US Japan. ";
      if (Symbol() == "AUDJPY") FinSym = " Australain Japan. ";
      if (Symbol() == "CHFJPY") FinSym = " Swiss France Japan. ";
      if (Symbol() == "CADJPY") FinSym = " Canadian Japan. ";
      if (Symbol() == "NZDJPY") FinSym = " New Zealand Japan. ";
      if (Symbol() == "EURUSD") FinSym = " Euro US. ";          // NOTE 3 ...  Spelling may need to be altered to achieve correct pronunciation with your speech engine.
      if (Symbol() == "AUDUSD") FinSym = " Australain US. ";   // NOTE 3 ...  Additional pairs can be added in the same manner.
      if (Symbol() == "USDCAD") FinSym = " US Canadian. ";
      if (Symbol() == "USDCHF") FinSym = " US swiss France. ";  

      if (Period() == 1) ChartPeriod = " Minute One ! ";       // NOTE 3 ...  Provides pronunciation for the Period() of the chart.
      if (Period() == 5) ChartPeriod = " Minute Five ! ";      // NOTE 3 ...  Spelling may need to be altered to achieve correct pronunciation with your speech engine.
      if (Period() == 15) ChartPeriod = " Minute Fifteen ! ";
      if (Period() == 30) ChartPeriod = " Minute Thirty ! ";
      if (Period() == 60) ChartPeriod = " One Hour ! ";
      if (Period() == 240) ChartPeriod = " Four Hour ! ";
      if (Period() == 1440) ChartPeriod = " Daily ! ";
      if (Period() == 10080) ChartPeriod = " Weekly ! ";
      if (Period() == 43200) ChartPeriod = " Monthly ! ";
      
            
      string CurrentPrice = DoubleToStr(Bid, Digits);     
   
//-----------   
   for(i=0,y=0;i<limit;i++)
   {
      if (Time[i]<TimeArray[y]) y++;

/***********************************************************   
   Add your main indicator loop below.  You can reference an existing
      indicator with its iName  or iCustom.
   Rule 1:  Add extern inputs above for all neccesary values   
   Rule 2:  Use 'TimeFrame' for the indicator time frame
   Rule 3:  Use 'y' for your indicator's shift value
 **********************************************************/  
 
      ExtMapBuffer1[i]=iMACD(NULL,TimeFrame,FastEMA,SlowEMA,SignalSMA,Applied_Price,0,y); 
      ExtMapBuffer2[i]=iMACD(NULL,TimeFrame,FastEMA,SlowEMA,SignalSMA,Applied_MAMode,1,y);
      ExtMapBuffer3[i]=ExtMapBuffer1[i]-ExtMapBuffer2[i];
      ExtMapBuffer4[i]=ExtMapBuffer1[i]-ExtMapBuffer2[i];
   
      if (ExtMapBuffer1[i] <= ExtMapBuffer2[i]) 
      {
        ExtMapBuffer3[i]=0;
         if (i == 1 && flagval2==0)
         {
          flagval2=1;
          flagval1=0;
          if (AlertON) Alert(Symbol(),"  M",Period(), ":  MACD ("+FastEMA+"-"+SlowEMA+"-"+SignalSMA+") (",TimeToStr(Time[1],TIME_SECONDS),")  Dn .. 4hr MACD Below 0");
          if (SpeechOn) gSpeak ("Mac D! One Hour! is Down");
         }
      }
      else
      {
         ExtMapBuffer4[i]=0;
         if (i == 1 && flagval1==0)
         {
          flagval1=1;
          flagval2=0;
          if (AlertON) Alert(Symbol(),"  M",Period(), ":  MACD ("+FastEMA+"-"+SlowEMA+"-"+SignalSMA+") (",TimeToStr(Time[1],TIME_SECONDS),")  Up .. 4hr MACD Above 0");
          if (SpeechOn) gSpeak ("Mac D! One Hour! is Up");
         }
      }
   
   }  
     
//
   
  
  
   return(0);
  }
//+------------------